/* WCEMenuBarPeer.java
   Copyright (C) 2005 Free Software Foundation, Inc.

This file is part of GNU Classpath.

GNU Classpath is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

GNU Classpath is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Classpath; see the file COPYING.  If not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA.

Linking this library statically or dynamically with other modules is
making a combined work based on this library.  Thus, the terms and
conditions of the GNU General Public License cover the whole
combination.

As a special exception, the copyright holders of this library give you
permission to link this library with independent modules to produce an
executable, regardless of the license terms of these independent
modules, and to copy and distribute the resulting executable under
terms of your choice, provided that you also meet, for each linked
independent module, the terms and conditions of the license of that
module.  An independent module is a module which is not derived from
or based on this library.  If you modify this library, you may extend
this exception to your version of the library, but you are not
obligated to do so.  If you do not wish to do so, delete this
exception statement from your version. */


package gnu.java.awt.peer.wce;

import java.awt.Menu;
import java.awt.MenuBar;
import java.awt.peer.MenuBarPeer;

public class WCEMenuBarPeer extends WCEMenuComponentPeer implements MenuBarPeer {
	
	/**
	 * メニューバーのウインドウハンドル
	 */
	private int menuBarWindowHandle;
	
	WCEMenuBarPeer(MenuBar menuBar) {
		super(menuBar);
	}
	
	/**
	 * メニューバーのウインドウハンドルを設定する。
	 * WCEFramePeer.setMenuBar()から呼び出される
	 */
	void setMenuBarWindowHandle(int handle) {
		this.menuBarWindowHandle = handle;
	}
	
	/**
	 * メニューバーのウインドウハンドルを返す
	 */
	int getMenuBarWindowHandle() {
		return this.menuBarWindowHandle;
	}
	
	/**
	 * 指定されたMenuPeerをメニューバーに追加する
	 */
	void add(WCEMenuPeer menuPeer) {
		menuPeer.setMenuBarPeer(this);
		
		Menu menu = (Menu) menuPeer.getMenuComponent();
		addNativeMenu(getMenuBarWindowHandle(),
					  menuPeer.getMenuHandle(),
					  menu.getLabel());
	}
	
	/**
	 * 指定されたメニューをメニューバーに追加する
	 *
	 * @param	menuBarWindowHandle	メニューバーのウインドウハンドル
	 * @paam	menuHandle			追加するメニューのメニューハンドル
	 * @param	label				ラベル
	 */
	native void addNativeMenu(int menuBarWindowHandle, int menuHandle, String label);
	
	
	public void addHelpMenu(Menu menu) {
		// ToDo:ヘルプメニュー追加処理
	}
	
	/**
	 * 指定されたインデックス位置にあるメニューを
	 * メニューバーから削除する
	 */
	public void delMenu(int index) {
		deleteNativeMenuByPosition(getMenuBarWindowHandle(), index);
	}
	
	/**
	 * このメニューバーに関連付けられたメニューバーの内容を
	 * 全てクリアする
	 */
	public void dispose() {
		disposeNativeMenuBar(getMenuBarWindowHandle());
	}
	
	private native void disposeNativeMenuBar(int menuBarWindowHandle);

	/**
	 * メニューをメニューバーから取り除く
	 */
	native void deleteNativeMenuByHandle(int menuBarWindowHandle, int menuHandle);

	/**
	 * メニューをメニューバーから取り除く
	 */
	private native void deleteNativeMenuByPosition(int menuBarWindowHandle, int index);


	public void addMenu(Menu m) {
		if (getMenuBarWindowHandle() != 0) {
			// すでにMenuBarが表示状態の場合は、追加する
			add((WCEMenuPeer) m.getPeer());
		} else {
			// （WCEFramePeer.setMenuBar()内で追加処理が行われるため、
			//  　非表示状態の場合には何もしない）
		}
	}

}
